summaryrefslogtreecommitdiffstats
path: root/modules.d/95dasd
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-06-03 13:54:25 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-06-03 13:54:25 +0000
commit9cb1c4df7b9ce1a9ad1312621b0f2b16a94fba3a (patch)
tree2efb72864cc69e174c9c5ee33efb88a5f1553b48 /modules.d/95dasd
parentInitial commit. (diff)
downloaddracut-9cb1c4df7b9ce1a9ad1312621b0f2b16a94fba3a.tar.xz
dracut-9cb1c4df7b9ce1a9ad1312621b0f2b16a94fba3a.zip
Adding upstream version 060+5.upstream/060+5
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to '')
-rwxr-xr-xmodules.d/95dasd/module-setup.sh27
-rwxr-xr-xmodules.d/95dasd/parse-dasd.sh11
-rwxr-xr-xmodules.d/95dasd_mod/module-setup.sh27
-rwxr-xr-xmodules.d/95dasd_mod/parse-dasd-mod.sh18
-rwxr-xr-xmodules.d/95dasd_rules/module-setup.sh65
-rwxr-xr-xmodules.d/95dasd_rules/parse-dasd.sh43
6 files changed, 191 insertions, 0 deletions
diff --git a/modules.d/95dasd/module-setup.sh b/modules.d/95dasd/module-setup.sh
new file mode 100755
index 0000000..180da14
--- /dev/null
+++ b/modules.d/95dasd/module-setup.sh
@@ -0,0 +1,27 @@
+#!/bin/bash
+
+# called by dracut
+check() {
+ local _arch=${DRACUT_ARCH:-$(uname -m)}
+ [ "$_arch" = "s390" -o "$_arch" = "s390x" ] || return 1
+ require_binaries normalize_dasd_arg || return 1
+ return 0
+}
+
+# called by dracut
+depends() {
+ echo "dasd_mod"
+ return 0
+}
+
+# called by dracut
+install() {
+ inst_hook cmdline 30 "$moddir/parse-dasd.sh"
+ inst_multiple dasdinfo dasdconf.sh normalize_dasd_arg
+ conf=/etc/dasd.conf
+ if [[ $hostonly && -f $conf ]]; then
+ inst -H $conf
+ fi
+ inst_rules 56-dasd.rules
+ inst_rules 59-dasd.rules
+}
diff --git a/modules.d/95dasd/parse-dasd.sh b/modules.d/95dasd/parse-dasd.sh
new file mode 100755
index 0000000..cda3970
--- /dev/null
+++ b/modules.d/95dasd/parse-dasd.sh
@@ -0,0 +1,11 @@
+#!/bin/sh
+for dasd_arg in $(getargs rd.dasd= -d rd_DASD= DASD=); do
+ (
+ local OLDIFS="$IFS"
+ IFS=","
+ # shellcheck disable=SC2086
+ set -- $dasd_arg
+ IFS="$OLDIFS"
+ echo "$@" | normalize_dasd_arg >> /etc/dasd.conf
+ )
+done
diff --git a/modules.d/95dasd_mod/module-setup.sh b/modules.d/95dasd_mod/module-setup.sh
new file mode 100755
index 0000000..c59dd3a
--- /dev/null
+++ b/modules.d/95dasd_mod/module-setup.sh
@@ -0,0 +1,27 @@
+#!/bin/bash
+
+# called by dracut
+check() {
+ local _arch=${DRACUT_ARCH:-$(uname -m)}
+ [ "$_arch" = "s390" -o "$_arch" = "s390x" ] || return 1
+ require_binaries grep sed seq
+
+ return 0
+}
+
+# called by dracut
+depends() {
+ return 0
+}
+
+# called by dracut
+installkernel() {
+ instmods dasd_mod dasd_eckd_mod dasd_fba_mod dasd_diag_mod
+}
+
+# called by dracut
+install() {
+ inst_hook cmdline 31 "$moddir/parse-dasd-mod.sh"
+ inst_multiple grep sed seq
+ inst_multiple -o dasd_cio_free
+}
diff --git a/modules.d/95dasd_mod/parse-dasd-mod.sh b/modules.d/95dasd_mod/parse-dasd-mod.sh
new file mode 100755
index 0000000..2b86d45
--- /dev/null
+++ b/modules.d/95dasd_mod/parse-dasd-mod.sh
@@ -0,0 +1,18 @@
+#!/bin/sh
+mod_args=""
+
+for dasd_arg in $(getargs rd.dasd= -d rd_DASD= DASD=); do
+ mod_args="$mod_args,$dasd_arg"
+done
+
+mod_args="${mod_args#*,}"
+
+if [ -x /sbin/dasd_cio_free -a -n "$mod_args" ]; then
+ [ -d /etc/modprobe.d ] || mkdir -m 0755 -p /etc/modprobe.d
+ echo "options dasd_mod dasd=$mod_args" >> /etc/modprobe.d/dasd_mod.conf
+fi
+
+unset dasd_arg
+if [ -x /sbin/dasd_cio_free ]; then
+ dasd_cio_free
+fi
diff --git a/modules.d/95dasd_rules/module-setup.sh b/modules.d/95dasd_rules/module-setup.sh
new file mode 100755
index 0000000..06c57a4
--- /dev/null
+++ b/modules.d/95dasd_rules/module-setup.sh
@@ -0,0 +1,65 @@
+#!/bin/bash
+
+# called by dracut
+cmdline() {
+ is_dasd() {
+ local _dev=$1
+ local _devpath
+ _devpath=$(
+ cd -P /sys/dev/block/"$_dev" || exit
+ echo "$PWD"
+ )
+
+ [ "${_devpath#*/dasd}" == "$_devpath" ] && return 1
+ _ccw="${_devpath%%/block/*}"
+ echo "rd.dasd=${_ccw##*/}"
+ return 0
+ }
+ [[ $hostonly ]] || [[ $mount_needs ]] && {
+ for_each_host_dev_and_slaves_all is_dasd || return 255
+ } | sort | uniq
+}
+
+# called by dracut
+check() {
+ local _arch=${DRACUT_ARCH:-$(uname -m)}
+ local found=0
+ local bdev
+ [ "$_arch" = "s390" -o "$_arch" = "s390x" ] || return 1
+
+ [[ $hostonly ]] || [[ $mount_needs ]] && {
+ for bdev in /sys/block/*; do
+ case "${bdev##*/}" in
+ dasd*)
+ found=$((found + 1))
+ break
+ ;;
+ esac
+ done
+ [ $found -eq 0 ] && return 255
+ }
+ return 0
+}
+
+# called by dracut
+depends() {
+ echo 'dasd_mod' bash
+ return 0
+}
+
+# called by dracut
+install() {
+ inst_hook cmdline 30 "$moddir/parse-dasd.sh"
+ if [[ $hostonly_cmdline == "yes" ]]; then
+ local _dasd
+ _dasd=$(cmdline)
+ [[ $_dasd ]] && printf "%s\n" "$_dasd" >> "${initdir}/etc/cmdline.d/95dasd.conf"
+ fi
+ if [[ $hostonly ]]; then
+ inst_rules_wildcard "51-dasd-*.rules"
+ inst_rules_wildcard "41-dasd-*.rules"
+ mark_hostonly /etc/udev/rules.d/51-dasd-*.rules
+ mark_hostonly /etc/udev/rules.d/41-dasd-*.rules
+ fi
+ inst_rules 59-dasd.rules
+}
diff --git a/modules.d/95dasd_rules/parse-dasd.sh b/modules.d/95dasd_rules/parse-dasd.sh
new file mode 100755
index 0000000..4454aec
--- /dev/null
+++ b/modules.d/95dasd_rules/parse-dasd.sh
@@ -0,0 +1,43 @@
+#!/bin/bash
+
+allow_device() {
+ local ccw=$1
+
+ if [ -x /sbin/cio_ignore ] && cio_ignore -i "$ccw" > /dev/null; then
+ cio_ignore -r "$ccw"
+ fi
+}
+
+if [[ -f /sys/firmware/ipl/ipl_type ]] && [[ $(< /sys/firmware/ipl/ipl_type) == "ccw" ]]; then
+ allow_device "$(< /sys/firmware/ipl/device)"
+fi
+
+for dasd_arg in $(getargs root=) $(getargs resume=); do
+ [[ $dasd_arg =~ /dev/disk/by-path/ccw-* ]] || continue
+
+ ccw_dev="${dasd_arg##*/ccw-}"
+ allow_device "${ccw_dev%%-*}"
+done
+
+for dasd_arg in $(getargs rd.dasd=); do
+ IFS=',' read -r -a devs <<< "$dasd_arg"
+ declare -p devs
+ for dev in "${devs[@]}"; do
+ case "$dev" in
+ autodetect | probeonly) ;;
+
+ *-*)
+ IFS="-" read -r start end _ <<< "${dev%(ro)}"
+ prefix=${start%.*}
+ start=${start##*.}
+ for rdev in $(seq $((16#$start)) $((16#$end))); do
+ allow_device "$(printf "%s.%04x" "$prefix" "$rdev")"
+ done
+ ;;
+ *)
+ IFS="." read -r sid ssid chan _ <<< "${dev%(ro)}"
+ allow_device "$(printf "%01x.%01x.%04x" $((16#$sid)) $((16#$ssid)) $((16#$chan)))"
+ ;;
+ esac
+ done
+done